//
//  ContentListViewController.m
//  Guardian
//
//  Created by Matt Biddulph on 05/03/2009.
//  Copyright 2009 Hackdiary Ltd. All rights reserved.
//

#import "GuardianAppDelegate.h"
#import "GuardianContent.h"
#import "ContentListViewController.h"
#import "ContentViewController.h"
#import "ContentTableViewCell.h"


@implementation ContentListViewController
@synthesize contents;
@synthesize tableView;
@synthesize filter;

- (void)setContentList:(NSArray *)content {
	//NSLog(@"Content:\n%@", content);
	self.contents = content;
	[[self tableView] reloadData];
}

/*
- (id)initWithStyle:(UITableViewStyle)style {
    // Override initWithStyle: if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
    if (self = [super initWithStyle:style]) {
    }
    return self;
}
*/

/*
- (void)viewDidLoad {
    [super viewDidLoad];

    // Uncomment the following line to display an Edit button in the navigation bar for this view controller.
    // self.navigationItem.rightBarButtonItem = self.editButtonItem;
}
*/

- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
	self.contents = [NSArray array];
	
	GuardianAppDelegate *delegate = (GuardianAppDelegate *)[[UIApplication sharedApplication] delegate];
	if(self.filter) {
		[delegate.guardian searchWithFilter:self.filter withDelegate:self didSucceedSelector:@selector(setContentList:)];
	} else {
		[delegate.guardian latestContentWithDelegate:self didSucceedSelector:@selector(setContentList:)];
	}
}

/*
- (void)viewDidAppear:(BOOL)animated {
    [super viewDidAppear:animated];
}
*/
/*
- (void)viewWillDisappear:(BOOL)animated {
	[super viewWillDisappear:animated];
}
*/
/*
- (void)viewDidDisappear:(BOOL)animated {
	[super viewDidDisappear:animated];
}
*/

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning]; // Releases the view if it doesn't have a superview
    // Release anything that's not essential, such as cached data
}

#pragma mark Table view methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
	return 1;
}


// Customize the number of rows in the table view.
- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
	return [self.contents count];
}


// Customize the appearance of table view cells.
- (UITableViewCell *)tableView:(UITableView *)tView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    static NSString *CellIdentifier = @"Cell";
    
    ContentTableViewCell *cell = (ContentTableViewCell *)[tView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
		cell = [[[ContentTableViewCell alloc] initWithFrame:CGRectZero reuseIdentifier:CellIdentifier] autorelease];
    }
    
    GuardianContent *content = [self.contents objectAtIndex:indexPath.row];
	[cell setGuardianContent:content];

    return cell;
}


- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath {
	GuardianContent *content = [self.contents objectAtIndex:indexPath.row];
	ContentViewController *contentViewController;
	contentViewController = [[ContentViewController alloc] 
							 initWithNibName:@"ContentViewController"
							 bundle:nil]; 
	contentViewController.content = content;
	[self.navigationController pushViewController:contentViewController animated:YES]; 
	[contentViewController release]; 
}

/* - (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath {
	GuardianContent *content = [self.contents objectAtIndex:indexPath.row];
	CGSize constSize = { 320.0f, 20000.0f };

	CGSize headlineSize = [content.headline sizeWithFont:[UIFont boldSystemFontOfSize:14] constrainedToSize:constSize lineBreakMode:UILineBreakModeWordWrap];
	CGSize standfirstSize = [content.standfirst sizeWithFont:[UIFont systemFontOfSize:11] constrainedToSize:constSize lineBreakMode:UILineBreakModeWordWrap];
	return headlineSize.height + standfirstSize.height;
}*/

/*
// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the specified item to be editable.
    return YES;
}
*/


/*
// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:YES];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}
*/


/*
// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath {
}
*/


/*
// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath {
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}
*/


- (void)dealloc {
	[filter release];
	[tableView release];
	[contents release];
    [super dealloc];
}


@end

